proc Version {} {global t tkrat_version tkrat_version_date
set w .about
if [winfo exists $w] {wm deiconify $w
raise $w
return}
toplevel $w -relief raised
wm title $w $t(about)
wm minsize $w 1 1
label $w.tkrat -text "TkRat v$tkrat_version" -font "-Adobe-Helvetica-Bold-R-Normal--24-*"
label $w.date -text $tkrat_version_date -font "-Adobe-Helvetica-Bold-R-Normal--12-*"
label $w.version -text "TkRat is copyright 1995,1996,1997 by" -font "-Adobe-Helvetica-Bold-R-Normal--12-*"
label $w.author -text "Martin Forssn (maf@math.chalmers.se)" -font "-Adobe-Helvetica-Bold-R-Normal--12-*"
message $w.more -text $t(send_bugs_etc) -aspect 700
text $w.text -relief flat -width 40 -height 8 -font "-Adobe-Helvetica-Bold-R-Normal--12-*"
$w.text insert 1.0 $t(send_postcards)
button $w.ok -text $t(ok) -command "RecordPos $w about; destroy $w" -width 20
pack $w.tkrat $w.date $w.version $w.author $w.more $w.text $w.ok -side top -padx 5 -pady 5
Place $w about}
proc Ratatosk {} {global t
set w .ratatosk
if [winfo exists $w] {wm deiconify $w
raise $w
return}
toplevel $w -relief raised
wm title $w Ratatosk
wm minsize $w 1 1
button $w.ok -text $t(ok) -command "RecordPos $w ratatosk; destroy $w" -width 20
message $w.message -aspect 400 -text $t(ratatosk)
pack $w.message $w.ok -side top -padx 5 -pady 5
Place $w ratatosk}
proc InfoWelcome {} {global b option changes welcomeLanguage
InitMessages $option(language) changes
toplevel .welcome
wm title .welcome $changes(welcome_title)
frame .welcome.message
text .welcome.message.text -relief sunken -bd 1 -yscrollcommand ".welcome.message.scroll set" -setgrid 1 -height 30 -width 80 -highlightthickness 0
scrollbar .welcome.message.scroll -relief sunken -bd 1 -command ".welcome.message.text yview" -highlightthickness 0
pack .welcome.message.scroll -side right -fill y
pack .welcome.message.text -expand 1 -fill both
.welcome.message.text insert 0.0 $changes(welcome)
.welcome.message.text configure -state disabled
frame .welcome.b
frame .welcome.b.lang
label .welcome.b.lang.label -textvariable changes(language)
menubutton .welcome.b.lang.menu -textvariable welcomeLanguage -indicatoron 1 -menu .welcome.b.lang.menu.m -relief raised -bd 1 -width 20 -anchor c
menu .welcome.b.lang.menu.m -tearoff 0
pack .welcome.b.lang.menu .welcome.b.lang.label -side right
set b(.welcome.b.lang.menu) welcome_lang
frame .welcome.b.shutup
label .welcome.b.shutup.label -textvariable changes(show_changes)
menubutton .welcome.b.shutup.menu -textvariable welcomeChanges -indicatoron 1 -menu .welcome.b.shutup.menu.m -relief raised -bd 1 -width 20 -anchor c
menu .welcome.b.shutup.menu.m -tearoff 0
pack .welcome.b.shutup.menu .welcome.b.shutup.label -side right
set b(.welcome.b.shutup.menu) welcome_shutup
button .welcome.b.cont -textvariable changes(continue) -bd 1 -command {destroy .welcome}
pack .welcome.b.lang .welcome.b.shutup -side top -fill x -pady 4
pack .welcome.b.cont -side top -pady 10
set b(.welcome.b.cont) welcome_cont
pack .welcome.message -side top -expand 1 -fill both -padx 5 -pady 5
pack .welcome.b
set i 0
foreach l [GetLanguages] {if ![string length [GetFont [lindex $l 2] 0 {}]] {continue}
.welcome.b.lang.menu.m add command -label [lindex $l 1] -command [list WelcomeLanguage $l]
if [RatEncodingCompat [lindex $l 2] $option(charset)] {set font [.welcome.b.lang.label cget -font]} {set font [GetFont [lindex $l 2] 0 bold]}
.welcome.b.lang.menu.m entryconfigure $i -font $font
incr i
if ![string compare [lindex $l 0] $option(language)] {WelcomeLanguage $l}}
Place .welcome welcome
tkwait window .welcome
foreach bn [array names b .welcome.*] {unset b($bn)}}
proc WelcomeShowMenu {{font {}}} {global option changes welcomeChanges
set m .welcome.b.shutup.menu.m
$m delete 0 end
if $option(info_changes) {set welcomeChanges $changes(show)} {set welcomeChanges $changes(dont_show)}
$m add command -label $changes(show) -command "set welcomeChanges [list $changes(show)] ;  set option(info_changes) 1"
$m add command -label $changes(dont_show) -command "set welcomeChanges [list $changes(dont_show)] ;  set option(info_changes) 0"
if [string length $font] {$m entryconfigure 0 -font $font
$m entryconfigure 1 -font $font}}
proc WelcomeLanguage lang {global welcomeLanguage option changes defaultFont
set font [GetFont [lindex $lang 2] 0 bold]
set welcomeLanguage [lindex $lang 1]
set option(language) [lindex $lang 0]
InitMessages $option(language) changes
wm title .welcome $changes(welcome_title)
.welcome.message.text configure -state normal -font [GetFont [lindex $lang 2] 0 {}]
.welcome.message.text delete 0.0 end
.welcome.message.text insert 0.0 $changes(welcome)
.welcome.message.text configure -state disabled
if [RatEncodingCompat [lindex $lang 2] $option(charset)] {foreach w {.welcome.b.lang.label .welcome.b.lang.menu .welcome.b.shutup.label .welcome.b.shutup.menu .welcome.b.cont} {$w configure -font [$w cget -font]}
WelcomeShowMenu} {foreach w {.welcome.b.lang.label .welcome.b.lang.menu .welcome.b.shutup.label .welcome.b.shutup.menu .welcome.b.cont} {$w configure -font $font}
WelcomeShowMenu $font}}
proc InfoChanges {} {global option changes changesDone changesChanges tkrat_version ratHistory b
InitMessages $option(language) changes
toplevel .changes
wm title .changes $changes(changes_title)
frame .changes.message
text .changes.message.text -relief sunken -bd 1 -yscrollcommand ".changes.message.scroll set" -setgrid 1 -height 30 -width 80 -highlightthickness 0
scrollbar .changes.message.scroll -relief sunken -bd 1 -command ".changes.message.text yview" -highlightthickness 0
pack .changes.message.scroll -side right -fill y
pack .changes.message.text -expand 1 -fill both
set starts "********************"
set i [expr [lsearch -exact $ratHistory $option(last_version)]+1]
foreach ver [lrange $ratHistory $i end] {.changes.message.text insert end "$starts $changes(changes_in) $ver $starts\n"
.changes.message.text insert end $changes($ver)
.changes.message.text insert end "\n\n\n"}
.changes.message.text configure -state disabled
frame .changes.b
frame .changes.b.shutup
label .changes.b.shutup.label -textvariable changes(show_changes)
menubutton .changes.b.shutup.menu -textvariable changesChanges -indicatoron 1 -menu .changes.b.shutup.menu.m -relief raised -bd 1 -width 20 -anchor c
menu .changes.b.shutup.menu.m -tearoff 0
pack .changes.b.shutup.menu .changes.b.shutup.label -side right
if $option(info_changes) {set changesChanges $changes(show)} {set changesChanges $changes(dont_show)}
.changes.b.shutup.menu.m add command -label $changes(show) -command "set changesChanges [list $changes(show)] ;  set option(info_changes) 1"
.changes.b.shutup.menu.m add command -label $changes(dont_show) -command "set changesChanges [list $changes(dont_show)] ;  set option(info_changes) 0"
set b(.changes.b.shutup.menu) welcome_shutup
button .changes.b.cont -textvariable changes(continue) -bd 1 -command {RecordPos .changes infoChanges
destroy .changes}
pack .changes.b.shutup -side top -pady 4
pack .changes.b.cont -side top -pady 10
set b(.changes.b.cont) welcome_cont
pack .changes.message -side top -expand 1 -fill both -padx 5 -pady 5
pack .changes.b
Place .changes infoChanges
tkwait window .changes
foreach bn [array names b .welcome.*] {unset b($bn)}}
proc SeeLog {} {global idCnt t
set id iw[incr idCnt]
set w .$id
toplevel $w
wm title $w $t(seelog_title)
button $w.button -text $t(close) -command "RecordPos $w seeLog;  RecordSize $w.list seeLog; destroy $w"
listbox $w.list -yscroll "$w.scroll set" -relief sunken -bd 1 -selectmode extended
Size $w.list seeLog
scrollbar $w.scroll -relief raised -bd 1 -command "$w.list yview"
pack $w.button -side bottom -padx 5 -pady 5
pack $w.scroll -side right -fill y
pack $w.list -expand 1 -fill both
foreach m [GetRatLog] {$w.list insert end $m}
Place $w seeLog}
proc SendBugReport {{attachments {}}} {global idCnt option t tkrat_version tkrat_version_date tcl_version tk_version tcl_patchLevel tk_patchLevel
set mhandler composeM[incr idCnt]
upvar #0 $mhandler mh
set mh(to) maf@dtek.chalmers.se
set mh(subject) "TkRat $tkrat_version bug: \[$t(short_description)\]"
set mh(description) "Bug report"
set mh(data) $t(bug_report_template)
foreach a $attachments {set ahandler composeB[incr idCnt]
upvar #0 $ahandler ah
lappend mh(attachmentList) $ahandler
set ah(type) text
set ah(subtype) plain
set ah(description) [lindex $a 0]
set ah(filename) [RatTildeSubst $option(send_cache)/rat.[RatGenId]]
set ah(removeFile) 1
set fh [open $ah(filename) w 0600]
puts $fh [lindex $a 1]
close $fh}
set ahandler composeB[incr idCnt]
upvar #0 $ahandler ah
lappend mh(attachmentList) $ahandler
set ah(type) text
set ah(subtype) plain
set ah(description) $t(configuration_information)
set ah(filename) [RatTildeSubst $option(send_cache)/rat.[RatGenId]]
set ah(removeFile) 1
set fh [open $ah(filename) w 0600]
catch {exec uname -a} uname
puts $fh "uname -a: '$uname'"
puts $fh "Version: $tkrat_version ($tkrat_version_date)"
puts $fh "Tcl/Tk: $tcl_version/$tk_version ($tcl_patchLevel/$tk_patchLevel)"
foreach n [lsort [array names tcl_platform]] {puts $fh "tcl_platform($n): '$tcl_platform($n)'"}
foreach n [lsort [array names option]] {puts $fh "option($n): '$option($n)'"}
close $fh
DoCompose $mhandler 0 1}
proc Warn tag {global idCnt t option
set id iw[incr idCnt]
set w .$id
set option($tag) 0
toplevel $w
wm title $w $t(warning)
message $w.msg -justify left -text $t($tag) -aspect 600 -relief raised -bd 1 -padx 5 -pady 5
checkbutton $w.but -text $t(do_not_show_again) -variable option($tag) -onvalue 0 -offvalue 1
button $w.dismiss -text $t(dismiss) -command "RecordPos $w warning; destroy $w"
pack $w.msg -side top
pack $w.but -side top -anchor w -pady 5 -padx 5
pack $w.dismiss -pady 5
Place $w warning
tkwait window $w}
